Freecad 0.17, Workflow, Probleme, Bugs, Wünsche

In diesem Forum Fragen und Diskussionen in Deutsch
Forum rules
Foren-Regeln und hilfreiche Informationen

WICHTIG: Bitte zuerst lesen, bevor Sie posten
wmayer
Site Admin
Posts: 14887
Joined: Thu Feb 19, 2009 10:32 am

Re: Freecad 0.17, Workflow, Probleme, Bugs, Wünsche

Postby wmayer » Mon Sep 25, 2017 2:35 pm

freecad-heini-1 wrote:Wie erzeugt man ein Base-Feature aus einem Body? Ich habe es mit Shapebinder versucht und daraus einen neuen Body erzeugt. Der beinhaltet dann ein Base-Feature, aber auch den Shapebinder (ohne Placement), zumindest wenn man die boolschen Verknüpfungen aufruft.
Das ist ein spezielles Objekt, das extra dafür eingeführt wurde, um externe Modelle in einen Body zu verlinken -- da Shape-Binder dafür ja nicht gedacht sind. Wie Stefan schon sagte, kann der Anwender diese Base-Features nicht selbst erzeugen, sondern werden vom Body erzeugt, nachdem man ein Modell importiert, selektiert und ein Body erstellt (wahlweise kann man das externe Modell nach dem Laden per Drag and drop in den Body verlinken).

In der Baumansicht siehst Du ja, dass das Modell immer noch außerhalb des Bodys liegt und im Body selbst ist das Objekt BaseFeature.
ickby wrote:Aber wieso sollten wir auf Krampf versuchen dieses Tool so massiv aufzuweiten? Das sehe ich noch nicht wirklich.
Meiner Meinung nach ist das weniger ein funktionelles Problem, sondern viel mehr ein ästhetisches Problem. Weil bei Boolschen Operation ein Body komplett als Kindeskind im anderen Body verschwindet, hat man am Ende genauso tief verschachtelte Baum-Strukturen wie in der Part-Workbench.
Die ganzen Funktionen in PDN waren immer so konditioniert, dass der Baum möglichst linear bleibt.

Mir persönlich ist das aber letzten Endes wurscht.
freecad-heini-1
Posts: 5903
Joined: Tue Jan 07, 2014 11:10 am
Contact:

Re: Freecad 0.17, Workflow, Probleme, Bugs, Wünsche

Postby freecad-heini-1 » Mon Sep 25, 2017 2:48 pm

Wie bereits gesagt, in Pro/E gibt es dafür den Copy-Geometrie Befehl. Auf diese Weise kann ich die Hülle eines Teiles in ein anderes Teil kopieren um dessen Referenzen nutzen zu können, so wie beim ShapeBinder, jedoch sind boolsche Operationen auch möglich und Placements gehen nicht verloren.
Ich verstehe ehrlich gesagt nicht, warum man das nicht in ähnlicher Form für Freecad übernimmt oder wenigstens einen Clone zur Verfügung stellt, der parametrisch an sein Elternelement geknüpft ist. Das würde sehr wahrscheinlich den Programmieraufwand vereinfachen und wäre für die Anwender viel einfacher zu verstehen. In FC0.16 geht das doch auch über Draft-Clone. Dann hätte man nur den Shapebinder und könnte auf das Base-Feature verzichten. Der ShapeBinder sollte Fremddaten und eigene Daten unterstützen, dann wäre der Workflow sauber und durchschaubar.
Body's bleiben so wie sie sind erhalten, der Shapebinder ist das Bindeglied zwischen den Teilen. Wenn er dann noch eine Sonderrolle bekommt, so dass zirkulare Referenzen unmöglich sind, oder mehrfach davor gewarnt wird, dann wäre es perfekt für Top-Down-Design.
wmayer
Site Admin
Posts: 14887
Joined: Thu Feb 19, 2009 10:32 am

Re: Freecad 0.17, Workflow, Probleme, Bugs, Wünsche

Postby wmayer » Mon Sep 25, 2017 4:52 pm

Also mit dem Base-Feature kann ich das genauso machen. Lade Deine beiden Projekt und führe diesen Python-Code in der Konsole aus:

Code: Select all

base=App.ActiveDocument.addObject("PartDesign::FeatureBase","Clone")
base.BaseFeature=App.ActiveDocument.Body001
base.Placement.Base.x=-10
base.Placement.Base.y=-1.25
App.ActiveDocument.recompute()
Danach aktiviere Body-Kunststoffteil_Wand und selektiere den Clone. Jetzt kann man die Cut-Operation ausführen. Wenn man jetzt z.B. den Radius im Sketch001 ändert, dann ändert sich Body-Kunststoffteil_Wand mit.
freecad-heini-1
Posts: 5903
Joined: Tue Jan 07, 2014 11:10 am
Contact:

Re: Freecad 0.17, Workflow, Probleme, Bugs, Wünsche

Postby freecad-heini-1 » Mon Sep 25, 2017 5:27 pm

wmayer wrote:
Mon Sep 25, 2017 4:52 pm
Also mit dem Base-Feature kann ich das genauso machen. Lade Deine beiden Projekt und führe diesen Python-Code in der Konsole aus:

Code: Select all

base=App.ActiveDocument.addObject("PartDesign::FeatureBase","Clone")
base.BaseFeature=App.ActiveDocument.Body001
base.Placement.Base.x=-10
base.Placement.Base.y=-1.25
App.ActiveDocument.recompute()
Danach aktiviere Body-Kunststoffteil_Wand und selektiere den Clone. Jetzt kann man die Cut-Operation ausführen. Wenn man jetzt z.B. den Radius im Sketch001 ändert, dann ändert sich Body-Kunststoffteil_Wand mit.
Danke Werner. Das wäre genial, wenn man ein Clone-Feature hätte. Leider passt das Placement noch nicht, denn der Clone ist um 90° gedreht und die X-Position stimmt auch nicht.
Datei zum Nachprüfen:
FC017_workflow_formenbau-1.fcstd
(30.03 KiB) Downloaded 22 times
chrisb
Posts: 18935
Joined: Tue Mar 17, 2015 9:14 am

Re: Freecad 0.17, Workflow, Probleme, Bugs, Wünsche

Postby chrisb » Mon Sep 25, 2017 5:39 pm

ickby wrote:
Mon Sep 25, 2017 8:44 am
Wegen des Klons, ich habe es gerade ausprobiert: Ein Klon kann aktuell nur Dinge clonen, die im selben CS wie der Klon liegt. Also im gleichen Part wie der Klon, nicht außerhalb des Parts. Entsprechend funktioniert es auch nicht, einen klon für die PDN boleans zu verwenden, da er dann in einem anderen CS liegt (Ein boolean ist ein eigenes CS innerhalb des Body CS).
Genau das wollte ich machen: einen Body innerhalb eines Parts klonen. Kann ich dafür sorgen, dass der Klon im Part landet? Möglicherweise ist es bei mir ein Problem, das ich Expressions zu anderen Parts und anderen Bodies in anderen Parts verwende?
freecad-heini-1
Posts: 5903
Joined: Tue Jan 07, 2014 11:10 am
Contact:

Re: Freecad 0.17, Workflow, Probleme, Bugs, Wünsche

Postby freecad-heini-1 » Mon Sep 25, 2017 5:43 pm

Der ShapeBinder ist gut, aber das Placement sollte sich am Original orientieren.
Ich frage mich nämlich für welchem Fall ein ShapeBinder zurück zum Ursprungs Placement springen soll.
Einfach mal darüber nachdenken wie genial es ist, wenn mehrere Body's auf einen Shapebinder refenzieren und man sie gemeinsam verschieben und rotieren kann.
chrisb
Posts: 18935
Joined: Tue Mar 17, 2015 9:14 am

Re: Freecad 0.17, Workflow, Probleme, Bugs, Wünsche

Postby chrisb » Mon Sep 25, 2017 5:54 pm

freecad-heini-1 wrote:
Mon Sep 25, 2017 5:43 pm
Der ShapeBinder ist gut, aber das Placement sollte sich am Original orientieren.
Ich nutze hier einen ShapeBinder von einem Body, letzterer hat ein Z-Placement (ungleich 0). Wenn ich ein Part und darin einen Body und darin den Shapebinder erzeuge hat der auch dieselbe Z-Verschiebung, da scheint das zu funktionieren. Die zusätzliche Verschiebung des Parts wird nicht berücksichtigt.
wmayer
Site Admin
Posts: 14887
Joined: Thu Feb 19, 2009 10:32 am

Re: Freecad 0.17, Workflow, Probleme, Bugs, Wünsche

Postby wmayer » Mon Sep 25, 2017 7:25 pm

Danke Werner. Das wäre genial, wenn man ein Clone-Feature hätte. Leider passt das Placement noch nicht, denn der Clone ist um 90° gedreht und die X-Position stimmt auch nicht.
Datei zum Nachprüfen:
Das Projekt weicht aber von den beiden getrennten Original-Objekten ab. In dem Fall hast Du den 2. Body schon so hin verschoben und in dem Fall musst Du dieselben Placement-Daten übertragen.

Code: Select all

import math
base=App.ActiveDocument.Clone
plm=App.Placement()
plm.Base.x=-14
plm.Base.y=-1
plm.Rotation.Angle=math.pi/2
plm.Rotation.Axis=App.Vector(0,1,0)
base.Placement=plm
Leider funktioniert der Cut nicht mehr. Irgendwie sind die Abhängigkeiten in dem Projekt in Unordnung geraten.
freecad-heini-1
Posts: 5903
Joined: Tue Jan 07, 2014 11:10 am
Contact:

Re: Freecad 0.17, Workflow, Probleme, Bugs, Wünsche

Postby freecad-heini-1 » Mon Sep 25, 2017 9:33 pm

wmayer wrote:
Mon Sep 25, 2017 7:25 pm
Das Projekt weicht aber von den beiden getrennten Original-Objekten ab. In dem Fall hast Du den 2. Body schon so hin verschoben und in dem Fall musst Du dieselben Placement-Daten übertragen.
In diesem Thread findet man die Originaldaten. Der Schrifteinsatz liegt dabei noch nicht an der Stelle an die er soll:
https://forum.freecadweb.org/viewtopic. ... 82#p191482
freecad-heini-1
Posts: 5903
Joined: Tue Jan 07, 2014 11:10 am
Contact:

Re: Freecad 0.17, Workflow, Probleme, Bugs, Wünsche

Postby freecad-heini-1 » Tue Sep 26, 2017 6:23 am

wmayer wrote:
Mon Sep 25, 2017 7:25 pm
Das Projekt weicht aber von den beiden getrennten Original-Objekten ab. In dem Fall hast Du den 2. Body schon so hin verschoben und in dem Fall musst Du dieselben Placement-Daten übertragen.
Hier die Datei mit dem Schriftstempel an der gewünschten Position:
FC017_workflow_formenbau-2.fcstd
(43.7 KiB) Downloaded 19 times
Bitte wende Dein Skript an und schau was passiert. Bei mir dreht sich der Schriftstempel um 90° und eine Achse wird verschoben.